const program = require("commander");
const fs = require("fs");
module.exports = class Deploy {
  run() {
    // 获取命令执行文件的路径( __dirname： 被执行js文件的绝对路径)
    const commandsPath = `${__dirname}/commands`;
    // 对命令执行文件进行遍历，进行命令注册
    fs.readdirSync(`${commandsPath}`).forEach((fileName) => {
      const command = require(`${commandsPath}/${fileName}`);
      // 截取文件名作为命令名称
      const commandName = fileName.split(".")[0];
      // 进行命令的注册
      if (command.option) {
        program
          .command(commandName)
          .description(command.description)
          .option(command.option, command.optionDescription)
          .action((options) => {
            command.run(options.type);
          });
      } else {
        program
          .command(commandName)
          .description(command.description)
          .action((options) => {
            command.run(options.type);
          });
      }
    });
    // 解析命令行参数
    program.parse(process.argv);
  }
};
